You are given a 0-indexed array of integers nums.
A prefix nums[0..i] is sequential if, for all 1 <= j <= i, nums[j] = nums[j - 1] + 1. In particular, the prefix consisting only of nums[0] is sequential.
Return the smallest integer x missing from nums such that x is greater than or equal to the sum of the longest sequential prefix.
Example 1:
Input: nums = [1,2,3,2,5]
Output: 6
Explanation: The longest sequential prefix of nums is [1,2,3] with a sum of 6. 6 is not in the array, therefore 6 is the smallest missing integer greater than or equal to the sum of the longest sequential prefix.
Example 2:
Input: nums = [3,4,5,1,12,14,13]
Output: 15
Explanation: The longest sequential prefix of nums is [3,4,5] with a sum of 12. 12, 13, and 14 belong to the array while 15 does not. Therefore 15 is the smallest missing integer greater than or equal to the sum of the longest sequential prefix.
Constraints:
1 <= nums.length <= 50
1 <= nums[i] <= 50
My Solution
We can first store all the elements of nums into a HashSet for fast access. Then we iterate from the start of the array. While numbers increase by 1 on each iteration, we maintain the sum. Finally we keep incrementing the sum until the number is not in our HashSet, at which point we return the result.
Time complexity is O(n), where n is the size of nums because we iterate once to create the HashSet, then again to maintain our sum. Space complexity is O(n) due to the HashSet.
class Solution {
public int missingInteger(int[] nums) {
Set<Integer> all = new HashSet<>();
int sum = nums[0];
int n = nums.length;
for (int num : nums) {
all.add(num);
}
for (int i = 1; i < n; i++) {
if (nums[i] == nums[i-1]+1) {
sum += nums[i];
}
else {
break;
}
}
while (all.contains(sum)) {
sum++;
}
return sum;
}
}